import { calculateAABBCollision } from '../calculateAABBCollision/calculateAABBCollision';

/**
 * Вычисляет направление наибольшего пересечения по осям и возвращает tuple множителей для изменения координат
 * @param {Object} firstObject - первый объект
 * @param {number} firstObject.left - Min X координата первого объекта
 * @param {number} firstObject.right - Max X координата первого объекта
 * @param {number} firstObject.top - Min Y координата первого объекта (ось смотрит вниз)
 * @param {number} firstObject.bottom - Max Y координата первого объекта
 * @param {Object} secondObject - второй объект
 * @param {number} secondObject.left - Min X координата второго объекта
 * @param {number} secondObject.right - Max X координата второго объекта
 * @param {number} secondObject.top - Min Y координата второго объекта (ось смотрит вниз)
 * @param {number} secondObject.bottom - Max Y координата второго объекта
 * @returns {Array} tuple формата [1, -1] с множителями для осей X и Y. Каждый может принимать значение либо 1, либо -1
 */
export function calculateDirection(firstObject, secondObject) {
  try {
    // Запускаем для проверки формата аргументов
    const isCollided = calculateAABBCollision(firstObject, secondObject);

    if (isCollided === null) {
      return null;
    }

    if (!isCollided) {
      return [1, 1];
    }

    // Смотрим по какой оси значение пересечения объектов больше и выбираем множитель по
    const valueX = Math.min(firstObject.right, secondObject.right) - Math.max(firstObject.left, secondObject.left);
    const valueY = Math.min(firstObject.bottom, secondObject.bottom) - Math.max(firstObject.top, secondObject.top);

    switch (true) {
      // TODO: добавить эпсилон для сравнения
      case valueX === valueY:
        return [-1, -1];

      case valueX > valueY:
        return [1, -1];

      case valueX < valueY:
        return [-1, 1];

      default:
        return [1, 1];
    }
  } catch (err) {
    console.error(err);
    return null;
  }
}
